xref: /titanic_50/usr/src/cmd/calendar/calendar.sh (revision 7c478bd95313f5f23a4c958a745db2134aa03244)
1*7c478bd9Sstevel@tonic-gate#!/usr/bin/sh
2*7c478bd9Sstevel@tonic-gate#
3*7c478bd9Sstevel@tonic-gate# CDDL HEADER START
4*7c478bd9Sstevel@tonic-gate#
5*7c478bd9Sstevel@tonic-gate# The contents of this file are subject to the terms of the
6*7c478bd9Sstevel@tonic-gate# Common Development and Distribution License, Version 1.0 only
7*7c478bd9Sstevel@tonic-gate# (the "License").  You may not use this file except in compliance
8*7c478bd9Sstevel@tonic-gate# with the License.
9*7c478bd9Sstevel@tonic-gate#
10*7c478bd9Sstevel@tonic-gate# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
11*7c478bd9Sstevel@tonic-gate# or http://www.opensolaris.org/os/licensing.
12*7c478bd9Sstevel@tonic-gate# See the License for the specific language governing permissions
13*7c478bd9Sstevel@tonic-gate# and limitations under the License.
14*7c478bd9Sstevel@tonic-gate#
15*7c478bd9Sstevel@tonic-gate# When distributing Covered Code, include this CDDL HEADER in each
16*7c478bd9Sstevel@tonic-gate# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
17*7c478bd9Sstevel@tonic-gate# If applicable, add the following below this CDDL HEADER, with the
18*7c478bd9Sstevel@tonic-gate# fields enclosed by brackets "[]" replaced with your own identifying
19*7c478bd9Sstevel@tonic-gate# information: Portions Copyright [yyyy] [name of copyright owner]
20*7c478bd9Sstevel@tonic-gate#
21*7c478bd9Sstevel@tonic-gate# CDDL HEADER END
22*7c478bd9Sstevel@tonic-gate#
23*7c478bd9Sstevel@tonic-gate#	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T
24*7c478bd9Sstevel@tonic-gate#	  All Rights Reserved
25*7c478bd9Sstevel@tonic-gate
26*7c478bd9Sstevel@tonic-gate
27*7c478bd9Sstevel@tonic-gate#	Copyright (c) 1999 by Sun Microsystems, Inc.
28*7c478bd9Sstevel@tonic-gate#	All rights reserved.
29*7c478bd9Sstevel@tonic-gate
30*7c478bd9Sstevel@tonic-gate#ident	"%Z%%M%	%I%	%E% SMI"	/* SVr4.0 1.8	*/
31*7c478bd9Sstevel@tonic-gate#	calendar.sh - calendar command, uses /usr/lib/calprog
32*7c478bd9Sstevel@tonic-gate
33*7c478bd9Sstevel@tonic-gatePATH=/usr/bin
34*7c478bd9Sstevel@tonic-gateUSAGE="usage: calendar [ - ]"
35*7c478bd9Sstevel@tonic-gate
36*7c478bd9Sstevel@tonic-gate# mktmpdir - Create a private (mode 0700) temporary directory inside of /tmp
37*7c478bd9Sstevel@tonic-gatemktmpdir() {
38*7c478bd9Sstevel@tonic-gate	tmpdir=/tmp/calendar.$$
39*7c478bd9Sstevel@tonic-gate	/usr/bin/mkdir -m 700 $tmpdir || exit 1
40*7c478bd9Sstevel@tonic-gate}
41*7c478bd9Sstevel@tonic-gatemktmpdir
42*7c478bd9Sstevel@tonic-gate_tmp=$tmpdir/cal$$
43*7c478bd9Sstevel@tonic-gate
44*7c478bd9Sstevel@tonic-gatecleanup()
45*7c478bd9Sstevel@tonic-gate{
46*7c478bd9Sstevel@tonic-gate	/usr/bin/rm -rf $tmpdir
47*7c478bd9Sstevel@tonic-gate}
48*7c478bd9Sstevel@tonic-gate
49*7c478bd9Sstevel@tonic-gate# Trap on SIGHUP, SIGINT, SIGQUIT, SIGPIPE, SIGTERM
50*7c478bd9Sstevel@tonic-gatefor i in 1 2 3 13 15
51*7c478bd9Sstevel@tonic-gatedo
52*7c478bd9Sstevel@tonic-gate	# Ignore trap if already set by the shell.  NOTE: If /bin/sh
53*7c478bd9Sstevel@tonic-gate	# is made XCU4 compliant, updates will also be required to this
54*7c478bd9Sstevel@tonic-gate	# if statement because of XCU4 changes to the trap built-in.
55*7c478bd9Sstevel@tonic-gate	TRAP_IGNORE=`trap | egrep -c "^$i:\$"`
56*7c478bd9Sstevel@tonic-gate	if [ "$TRAP_IGNORE" != "1" ]
57*7c478bd9Sstevel@tonic-gate	then
58*7c478bd9Sstevel@tonic-gate		# Cleanup; reset default value; send signal to process.
59*7c478bd9Sstevel@tonic-gate		trap "cleanup; trap $i; kill -$i $$" $i
60*7c478bd9Sstevel@tonic-gate	fi
61*7c478bd9Sstevel@tonic-gatedone
62*7c478bd9Sstevel@tonic-gate
63*7c478bd9Sstevel@tonic-gate# POSIX.2 and XCU4 specify that if a utility accepts an operand,
64*7c478bd9Sstevel@tonic-gate# it also handle -- as a delimitor.
65*7c478bd9Sstevel@tonic-gateif [ "$1" = -- ]; then
66*7c478bd9Sstevel@tonic-gate	shift
67*7c478bd9Sstevel@tonic-gatefi
68*7c478bd9Sstevel@tonic-gate
69*7c478bd9Sstevel@tonic-gatecase $# in
70*7c478bd9Sstevel@tonic-gate0)	if [ -f calendar ]; then
71*7c478bd9Sstevel@tonic-gate		/usr/lib/calprog > ${_tmp}
72*7c478bd9Sstevel@tonic-gate		egrep -f ${_tmp} calendar
73*7c478bd9Sstevel@tonic-gate	else
74*7c478bd9Sstevel@tonic-gate		echo >&2 $0: `pwd`/calendar not found
75*7c478bd9Sstevel@tonic-gate		exit 1
76*7c478bd9Sstevel@tonic-gate	fi;;
77*7c478bd9Sstevel@tonic-gate*)	case $* in
78*7c478bd9Sstevel@tonic-gate	-)	if (rpcinfo -p | fgrep -s ypbind); then
79*7c478bd9Sstevel@tonic-gate			caldata="ypcat passwd.byname | grep /`uname -n`/"
80*7c478bd9Sstevel@tonic-gate		else
81*7c478bd9Sstevel@tonic-gate			caldata="cat /dev/null"
82*7c478bd9Sstevel@tonic-gate		fi
83*7c478bd9Sstevel@tonic-gate		/usr/lib/calprog > ${_tmp}
84*7c478bd9Sstevel@tonic-gate		eval $caldata | cat /etc/passwd - | \
85*7c478bd9Sstevel@tonic-gate		sed 's/\([^:]*\):.*:\(.*\):[^:]*$/_dir=\2 _user=\1/' | \
86*7c478bd9Sstevel@tonic-gate		while read _token; do
87*7c478bd9Sstevel@tonic-gate			eval ${_token}	# evaluates _dir= and _user=
88*7c478bd9Sstevel@tonic-gate			if [ -s ${_dir}/calendar ]; then
89*7c478bd9Sstevel@tonic-gate				egrep -f ${_tmp} ${_dir}/calendar 2>/dev/null \
90*7c478bd9Sstevel@tonic-gate					> $tmpdir/calendar.$$
91*7c478bd9Sstevel@tonic-gate				if [ -s $tmpdir/calendar.$$ ]; then
92*7c478bd9Sstevel@tonic-gate					mail ${_user} < $tmpdir/calendar.$$
93*7c478bd9Sstevel@tonic-gate				fi
94*7c478bd9Sstevel@tonic-gate			fi
95*7c478bd9Sstevel@tonic-gate		done;;
96*7c478bd9Sstevel@tonic-gate	*)	echo >&2 $0: illegal option -- $@
97*7c478bd9Sstevel@tonic-gate		echo >&2 $USAGE
98*7c478bd9Sstevel@tonic-gate		exit 1
99*7c478bd9Sstevel@tonic-gate	esac
100*7c478bd9Sstevel@tonic-gateesac
101*7c478bd9Sstevel@tonic-gatecleanup
102*7c478bd9Sstevel@tonic-gateexit 0
103